
'-----------------------------------------------------------------------------------------------
'    Name:   SMEDIA_DEFS.INC    /   Include File
'    Date:   19-July-2002
'    Type:   Tiger-BASIC(tm) Source-Code
' Purpose:   Symbols for SMartMedia(tm) FLASH-Cards Access
'
' (C) - 2002 Copyright Wilke Technology GmbH, 52070 Aachen, Germany
'-----------------------------------------------------------------------------------------------




'-----------------------------------------------------------------------------------------------
' User Function Codes for SMartMedia I/O
'-----------------------------------------------------------------------------------------------
				' <------------ GET ----------->  <------------ PUT ----------->
#define ufunc_sm_mount	     2	' Mount-SMedia: ID+Infoset+iBlks  .             ...
#define ufunc_sm_unmount     3	' UN-Mount-SMedia - S-Media raus  .             ...
#define ufunc_sm_reset	     4	' Reset Smart-Media Card          .             ...
#define ufunc_sm_getstat     5	' Read-SMedia-Status-Byte         .             ...
#define ufunc_sm_getinfo     6	' GET ID + Infoset about SMedia   .             ...
#define ufunc_sm_getiblks    7	' GET invalid-Block-Table         .             ...
				'
#define ufunc_sm_eraseblk    17	' ERASE Block abs (not waiting)   ERASE Block abs (not waiting)

#define ufunc_sm_rdpage	     18	' READ-1-DATA-Page-abs            <--   <--   <--
#define ufunc_sm_wrpage	     18	'            -->   -->   -->      Write-1-Data-Page-abs

#define ufunc_sm_rdpagesp    19	' READ-1-DATA-Page-abs. +SPARE    <--   <--   <--
#define ufunc_sm_wrpagesp    19	'            -->   -->   -->      Write-1-Data-Page-abs + SPARE
'
#define ufunc_sm_chk_sfe     24	' READ & Check Spare-Field empty  .             ...
#define ufunc_sm_chk_pae     25	' READ & Check PAGE empty         .             ...
#define ufunc_sm_first_eblk  26	' Find-first-empty-Block          .             ...
#define ufunc_sm_first_epage 27	' Find-first-empty-Page-in-Blk    .             ...


'-----------------------------------------------------------------------------------------------
' Definitions for Infoset (ufunc_sm_getinfo)  -  Offsets in Result-String
'-----------------------------------------------------------------------------------------------
#define _SM_MAKER_CODE	      0 ' <1> Maker-Code = Hersteller
#define _SM_ID_CODE	      1 ' <1> ID-Code = Karten-Id (Speicher-Groesse)
#define _SM_ADR_BYTES_RD_WR   2 ' <1> ADR-Bytes in READ / WRITE:  3 or 4
#define _SM_ADR_BYTES_BLKERA  3 ' <1> ADR-Bytes in Block-ERASE: 2 or 3
#define _SM_ADR_OFFS_BLKERA   4 ' <1> Byte-Offset of ADR in Block-ERASE: typical = 1
#define _SM_BYTES_IN_SPARE    5 ' <2> Nr. of Bytes in Spare-Field (normal: 16 Bytes)
#define _SM_SPARE_ADR_MASK    7 ' <2> SPARE-ADR Mask (normal: 0FH)
#define _SM_BYTES_IN_PAGE     9 ' <4> Nr. of DATA Bytes in a Page (without spare-field)
#define _SM_PAGE_MASK	     13 ' <2> ADR-Mask for this Page  (==>  RAM1_BYTES_IN_PAGE - 1 )
#define _SM_PAGE_IMASK       15 ' <2> inverse ADR-Mask for this Page, zB:  1111 1110 0000 0000
#define _SM_PAGES_IN_BLOCK   17 ' <2> Nr. of Pages in a Block
#define _SM_BYTES_IN_BLOCK   19 ' <4> Nr. of DATA-Bytes in a Block
#define _SM_BLOCK_ADR_INCS   23 ' <4> Bloc-ADR Increment (i.d.R. identisch mit "RAM1_BYTES_IN_BLOCK")
#define _SM_BLOCK_MASK       27 ' <2> Block-ADR Mask
#define _SM_BLOCK_IMASK      29 ' <2> Block-ADR inverse Mask
#define _SM_BLOCK_ADR_SRL    31 ' <1> Block-ADR Shifts-Right:  ADR --> to Block-Number (2**14 = 16384 = 16KByte)
#define _SM_NO_OF_BLOCKS     32 ' <2> Total Number of "Blocks" in this SmartMedia Card
#define _SM_ADR_HIGH_BLOCK   34 ' <4> Base ADR of highest Block
#define _SM_ADR_END	     38 ' <4> End-ADR = 1.ADR hinter dem letzen Byte !!
#define _SM_DATA_SET_LEN     42 ' length of the ID-Data field


'-----------------------------------------------------------------------------------------------
' Variables for Infoset (ufunc_sm_getinfo)
'-----------------------------------------------------------------------------------------------
LONG  SM_MAKER_CODE		' <1> Maker-Code = Hersteller
LONG  SM_ID_CODE		' <1> ID-Code = Karten-Id (Speicher-Groesse)
LONG  SM_ADR_BYTES_RD_WR	' <1> ADR-Bytes in READ / WRITE:  3 oder 4
LONG  SM_ADR_BYTES_BLKERA	' <1> ADR-Bytes in Block-ERASE: 2 oder 3
LONG  SM_ADR_OFFS_BLKERA	' <1> Byte-Offset of ADR in Block-ERASE: typical = 1
LONG  SM_BYTES_IN_SPARE		' <2> Nr. of Bytes in Spare-Field (normal: 16 Bytes)
LONG  SM_SPARE_ADR_MASK		' <2> SPARE-ADR Mask (normal: 0FH)
LONG  SM_BYTES_IN_PAGE		' <4> Nr. of DATA Bytes in a Page (without spare-field)
LONG  SM_PAGE_MASK		' <2> ADR-Mask for this Page  (==>  RAM1_BYTES_IN_PAGE - 1 )
LONG  SM_PAGE_IMASK		' <2> inverse ADR-Mask for this Page, zB:  1111 1110 0000 0000
LONG  SM_PAGES_IN_BLOCK		' <2> Nr. of Pages in a Block
LONG  SM_BYTES_IN_BLOCK		' <4> Nr. of DATA-Bytes in a Block
LONG  SM_BLOCK_ADR_INCS		' <4> Bloc-ADR Increment (i.d.R. identisch mit "RAM1_BYTES_IN_BLOCK")
LONG  SM_BLOCK_MASK		' <2> Block-ADR Maske
LONG  SM_BLOCK_IMASK		' <2> Block-ADR inverse Maske
LONG  SM_BLOCK_ADR_SRL		' <1> Block-ADR Shifts-Right:  ADR --> to Block-Number (2**14 = 16384 = 16KByte)
LONG  SM_NO_OF_BLOCKS		' <2> Total Number of "Blocks" in this SmartMedia Card
LONG  SM_ADR_HIGH_BLOCK		' <4> Base ADR of highest Block
LONG  SM_ADR_END		' <4> End-ADR = 1.ADR hinter dem letzen Byte !!

LONG  SM_NO_OF_INVBLKS		' No-of-Invalid Blocks (total)

LONG  SM_MEDIA_BYTES		' no of bytes in Media
LONG  SM_MEDIA_MASK		' ADR-mask for whole media


'----------------------------------------------------------------------------------------
' Flag-Werte fuer "IO_LAST_RESULT" in "IO_CTRL_BLOCK"
'----------------------------------------------------------------------------------------
#DEFINE  OK_FLAG_VALUE    000H	' All OK, no Error, Function as wanted
				'--------------------------------------------------------
#DEFINE  WARN_DEV_1BUSY   010H	' Warning: Device is BUSY now
#DEFINE  WARN_DEV_2BUSY   011H	' Warning: Device is BUSY longer than expected (Timeout)
				'--------------------------------------------------------
#DEFINE  ERR_DEV_GENRL    020H	' Error:   General Device-Error, Device might not be inserted
				'--------------------------------------------------------
#DEFINE  ERR_DEV_UNMOUNT  021H	' Error:   Device is un-mounted (maybe removed)
#DEFINE  ERR_DEV_RES_SPC  022H	' Error:   Not-enough Space in String for this Result
#DEFINE  ERR_DEV_IBUSIZE  023H	' Error:   Internal-Buffer-Size too Small (Inv-Blk-Table-Space)
#DEFINE  ERR_DEV_NODATA   024H	' Error:   No Data, z.B. ADR-Ueberlauf oder nur noch inv-Blocks
#DEFINE  ERR_DEV_INVBLK   025H	' Error:   Invalid Block
#DEFINE  ERR_DEV_READERR  026H	' Error:   Smart-Media Read Error
'----------------------------------------------------------------------------------------


