''**************************************************************************
'' Definitions relevant for all FS layers
'' Co-including of all FS components
''**************************************************************************

#ifndef FS_COINC_INC
#define	FS_COINC_INC

#define SMCARD 44

#define FALSE		0
#define TRUE		1

#define	ERROR		-1
#define	NO_ASSIGN	-1

#define BYTESIZE	1
#define WORDSIZE	2
#define LONGSIZE	4
#define REALSIZE	8

#define	MSEC_PER_SECOND		1000

'' #define FS_SECURE_INIT
#ifdef FS_SECURE_INIT
#define FS_NUM_VARS_INIT_VALUE	0
#define FS_STR_VARS_INIT_VALUE	""
#endif	'' FS_SECURE_INIT

'' optimization; the directory entries for the actually opened files will be saved
'' in the RAM and written to the media during the synchronization process
#define DIR_ENTRIES_IN_RAM

'' optimization; file allocation table will be saved in the RAM and
'' written to the media during the synchronization process
#define FAT_IN_RAM

'' optimization; the currently used data block is kept in the RAM untill
'' the writing to the other block is demanded
#define SM_WRITE_ON_BLOCK_SWITCH

'' optimization; not tested; don't use it
'' #define INDEX_USE_DATA_POOLS

'' if this "define" is active, use the device driver settings for TEC system,
'' else set the parameters for the particular system separately
#define SM_SETUP_DRIVER_FOR_TEC

'' use fast functions to build a log-to-phys map
#define SM_USE_FAST_LOG2PHYS_FUNCS

#include fs_conf.inc

#include fs_smc_d.inc
#include fs_fat_d.inc
#include fs_inx_d.inc
#include fs_dat_d.inc

#include fs_dat_i.inc
#include fs_smc_i.inc
#include fs_hal_d.inc
#include fs_ecc_i.inc
#include fs_fat_i.inc
#include fs_fmt_i.inc
#include fs_inx_i.inc

#endif

