''**************************************************************************
'' Definitions that may be important for the user configuring BTFS
''**************************************************************************

#ifndef FS_CONF_INC
#define	FS_CONF_INC

'' maximal size of file allocation table
'' change the value only if the size and the formatting parameters of
'' the used storage media are definite
'' SSFDC documentation:
'' for 128Mb SmartMedia: 32 sectors * 512 bytes = 16k
'' Microsoft:
'' for 64Mb SmartMedia: 249 sectors * 512 bytes = 127488 bytes
'' for 128Mb SmartMedia: 250 sectors * 512 bytes = 128000 bytes
''
'' the following constants are not independent of each other:
'' MAX_FAT_SIZE = FAT_RAM_BUF_SIZE * FAT_RAM_BUF_NUM
'' to remind: the maximal string size is 32765 bytes
#define	MAX_FAT_SIZE		128k
#define	FAT_RAM_BUF_SIZE	4k
#define	FAT_RAM_BUF_NUM		32


'' the size of a special array with flags saying whether an appropriate area of
'' file allocation table was modified and must be actually written down to the media
#define	FAT_MODIFIED_AREAS_MAX_NUM	128


'' the number of files that can be simultaneously opened in the BTFS
#define	TOTAL_FILE_NUMBER	16


'' the maximal cluster size
'' change the value only if the size and the formatting parameters of
'' the used storage media are definite
#define	MAX_CLUSTER_SIZE		16k

'' please, do not activate it
'' #define CORRECT_RTC

#endif '' FS_CONF_INC

